#ifndef HEXEN_IN
#define HEXEN_IN

#define COMPILE_FOR_QCDE

#define HX_AFRIT_DASH_DELAY 20

#define HX_WRAITH_FX3COUNT 14

#define HX_DRAGONDELAY_MIN 16
#define HX_DRAGONDELAY_MAX 48
#define HX_DRAGONDELAY_MAXEXPLOSIVES 5
#define HX_DRAGONTEMPTID 900002

#define HX_BLOODSEEKER_BASESIZE 0.925
#define HX_BLOODSEEKERSIZE_INC 0.25
#define HX_BLOODSEEKERSIZE_TIME 24
#define HX_BLOODSEEKER_DISTANCE 512

#define HX_KORAX_SPIKEANGLE_WINDOW ((1.0 * 36) / 360) // 30 degrees
#define HX_KORAX_ITERATIONS 6
#define HX_KORAX_BASEDIST 128 // multiplied by mul and divided by div
#define HX_KORAX_DISTMUL 8
#define HX_KORAX_DISTDIV 5
#define HX_KORAX_SPIKEBASECOUNT 3
#define HX_KORAX_SPIKEADD 2 // adds 2 each iteration
#define HX_KORAX_SPIKETID 900003
#define HX_KORAX_WAITTIME 9

#define HX_HERSHEY_CUBE_TID 60000
#define HX_HERSHEY_ORBITER_TID 70000
#define HX_HERESIARCH_PAINWAIT 122 // around 3.5 seconds
#define HX_HERESIARCH_SHIELDRATE ((3 * 1.0) / 360)
#define HX_HERESIARCH_SHIELDTIME 508 // little less than 512
#define HX_HERESIARCH_CUBEZOFFSET 120.0
#define HX_HERESIARCH_CUBEBASESPEED 4
#define HX_HERESIARCH_CUBESPEEDCAP 15

#define HX_MAXPLAYERS 64
#define HX_PTID_START 1000

str WendigoWispItem[2] = {
	"HX_WendigoWispSpawner",
	"HX_WendigoWispChaseSpawner"
};

int GetHersheyBallSpeed(int owner, int counter) {
	if(CheckActorInventory(owner, "HersheyOnAttack"))
		return 0;
	if(counter / 3 > HX_HERESIARCH_CUBESPEEDCAP)
		counter = 3 * HX_HERESIARCH_CUBESPEEDCAP;
	return ((HX_HERESIARCH_CUBEBASESPEED + counter / 3) * 1.0) / 360;
}

int sqrt_z(int number)
{
	if(number <= 3)
	{
		if(number > 0)
		{
			return 1;
		}
		return 0;
	}
	
	int oldAns = number >> 1,                     
	    newAns = (oldAns + number / oldAns) >> 1; 
	
	while(newAns < oldAns)
	{
		oldAns = newAns;
		newAns = (oldAns + number / oldAns) >> 1;
	}

	return oldAns;
}

int GetDistance(int dx, int dy) {
	dx >>= 16;
	dy >>= 16;
	return sqrt_z(dx * dx + dy * dy);
}

#endif